"use strict";

function WriteTilesetFileH(width, height, layerName, fileName)
{
	const upperCaseName = layerName.toUpperCase();
	const defineName = "_" + upperCaseName + "_H";

	let output = "// This file was generated by TiledToGameBoy, DO NOT EDIT.\n\n";
	output += "#ifndef " + defineName + "\n";
	output += "#define " + defineName + "\n\n";

	output += "extern const UINT8 " + upperCaseName + "[];\n";
	output += "#define " + upperCaseName + "_WIDTH " + width + "\n";
	output += "#define " + upperCaseName + "_HEIGHT " + height + "\n\n";

	output += "#endif //" + defineName + "\n";

	const fileNameH = fileName.replace(".c", ".h");
	let file = new TextFile(fileNameH, TextFile.WriteOnly);
	file.write(output);
	file.commit();		
}

function WriteTilemapFileC(width, height, layer, fileName)
{
	let output = "// This file was generated by TiledToGameBoy, DO NOT EDIT.\n\n";
	output += "#include <types.h>\n\n";

	output += "const UINT8 " + layer.name.toUpperCase() + " = {\n";
	for (let i = 0; i < height; ++i)
	{
		output += "\t";
		for (let j = 0; j < width; ++j)
		{
			const tile = layer.tileAt(j, i);
			output += ((j > 0) ? " " : "") + "0x" + (tile != null ? tile.id.toString(16).padStart(2, '0') : "00") + ",";
		}

		output += "\n";
	}
	output += "};\n";

	let file = new TextFile(fileName, TextFile.WriteOnly);
	file.write(output);
	file.commit();	
}

var ExportToGB = {
	name: "GameBoy tilemap format",
	extension: "c *.h",

	write: function(map, fileName) {
		const width = map.width;
		const height = map.height;
		const layer = map.layerAt(0); // GameBoy tilemap as only one layer (background).

		WriteTilesetFileH(width, height, layer.name, fileName);
		WriteTilemapFileC(width, height, layer, fileName);
	}
};

tiled.registerMapFormat("custom", ExportToGB);